diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/etc/radiusclient.conf tomato121/release/src/router/pppd/pppd/plugins/radius/etc/radiusclient.conf
--- tomato/release/src/router/pppd/pppd/plugins/radius/etc/radiusclient.conf	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/etc/radiusclient.conf	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,91 @@
+# General settings
+
+# specify which authentication comes first respectively which
+# authentication is used. possible values are: "radius" and "local".
+# if you specify "radius,local" then the RADIUS server is asked
+# first then the local one. if only one keyword is specified only
+# this server is asked.
+auth_order	radius
+
+# maximum login tries a user has (default 4)
+login_tries	4
+
+# timeout for all login tries (default 60)
+# if this time is exceeded the user is kicked out 
+login_timeout	60
+
+# name of the nologin file which when it exists disables logins.
+# it may be extended by the ttyname which will result in
+# a terminal specific lock (e.g. /etc/nologin.ttyS2 will disable
+# logins on /dev/ttyS2)   (default /etc/nologin)
+nologin /etc/nologin
+
+# name of the issue file. it's only display when no username is passed
+# on the radlogin command line  (default /etc/radiusclient/issue)
+issue	/usr/local/etc/radiusclient/issue
+
+# RADIUS settings
+
+# RADIUS server to use for authentication requests. this config
+# item can appear more then one time. if multiple servers are
+# defined they are tried in a round robin fashion if one
+# server is not answering.
+# optionally you can specify a the port number on which is remote
+# RADIUS listens separated by a colon from the hostname. if
+# no port is specified /etc/services is consulted of the radius
+# service. if this fails also a compiled in default is used.
+authserver 	localhost:1812
+
+# RADIUS server to use for accouting requests. All that I
+# said for authserver applies, too. 
+#
+acctserver 	localhost:1813
+
+# file holding shared secrets used for the communication
+# between the RADIUS client and server
+servers		/usr/local/etc/radiusclient/servers
+
+# dictionary of allowed attributes and values
+# just like in the normal RADIUS distributions
+dictionary 	/usr/local/etc/radiusclient/dictionary
+
+# program to call for a RADIUS authenticated login 
+# (default /usr/sbin/login.radius)
+login_radius	/usr/local/sbin/login.radius
+
+# file which holds sequence number for communication with the
+# RADIUS server
+seqfile		/var/run/radius.seq
+
+# file which specifies mapping between ttyname and NAS-Port attribute
+mapfile		/usr/local/etc/radiusclient/port-id-map
+
+# default authentication realm to append to all usernames if no
+# realm was explicitly specified by the user
+# the radiusd directly form Livingston doesnt use any realms, so leave
+# it blank then
+default_realm
+
+# time to wait for a reply from the RADIUS server
+radius_timeout	10
+
+# resend request this many times before trying the next server
+radius_retries	3
+
+# NAS-Identifier
+#
+# If supplied, this option will cause the client to send the given string
+# as the contents of the NAS-Identifier attribute in RADIUS requests.  No
+# NAS-IP-Address attribute will be sent in this case.
+#
+# The default behavior is to send a NAS-IP-Address option and not send
+# a NAS-Identifier.  The value of the NAS-IP-Address option is chosen
+# by resolving the system hostname.
+
+# nas_identifier MyUniqueNASName
+
+# LOCAL settings
+
+# program to execute for local login
+# it must support the -f flag for preauthenticated login
+login_local	/bin/login
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/etc/radiusclient.conf.in tomato121/release/src/router/pppd/pppd/plugins/radius/etc/radiusclient.conf.in
--- tomato/release/src/router/pppd/pppd/plugins/radius/etc/radiusclient.conf.in	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/etc/radiusclient.conf.in	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,91 @@
+# General settings
+
+# specify which authentication comes first respectively which
+# authentication is used. possible values are: "radius" and "local".
+# if you specify "radius,local" then the RADIUS server is asked
+# first then the local one. if only one keyword is specified only
+# this server is asked.
+auth_order	radius
+
+# maximum login tries a user has (default 4)
+login_tries	4
+
+# timeout for all login tries (default 60)
+# if this time is exceeded the user is kicked out 
+login_timeout	60
+
+# name of the nologin file which when it exists disables logins.
+# it may be extended by the ttyname which will result in
+# a terminal specific lock (e.g. /etc/nologin.ttyS2 will disable
+# logins on /dev/ttyS2)   (default /etc/nologin)
+nologin /etc/nologin
+
+# name of the issue file. it's only display when no username is passed
+# on the radlogin command line  (default /etc/radiusclient/issue)
+issue	@pkgsysconfdir@/issue
+
+# RADIUS settings
+
+# RADIUS server to use for authentication requests. this config
+# item can appear more then one time. if multiple servers are
+# defined they are tried in a round robin fashion if one
+# server is not answering.
+# optionally you can specify a the port number on which is remote
+# RADIUS listens separated by a colon from the hostname. if
+# no port is specified /etc/services is consulted of the radius
+# service. if this fails also a compiled in default is used.
+authserver 	localhost:1812
+
+# RADIUS server to use for accouting requests. All that I
+# said for authserver applies, too. 
+#
+acctserver 	localhost:1813
+
+# file holding shared secrets used for the communication
+# between the RADIUS client and server
+servers		@pkgsysconfdir@/servers
+
+# dictionary of allowed attributes and values
+# just like in the normal RADIUS distributions
+dictionary 	@pkgsysconfdir@/dictionary
+
+# program to call for a RADIUS authenticated login 
+# (default /usr/sbin/login.radius)
+login_radius	@sbindir@/login.radius
+
+# file which holds sequence number for communication with the
+# RADIUS server
+seqfile		/var/run/radius.seq
+
+# file which specifies mapping between ttyname and NAS-Port attribute
+mapfile		@pkgsysconfdir@/port-id-map
+
+# default authentication realm to append to all usernames if no
+# realm was explicitly specified by the user
+# the radiusd directly form Livingston doesnt use any realms, so leave
+# it blank then
+default_realm
+
+# time to wait for a reply from the RADIUS server
+radius_timeout	10
+
+# resend request this many times before trying the next server
+radius_retries	3
+
+# NAS-Identifier
+#
+# If supplied, this option will cause the client to send the given string
+# as the contents of the NAS-Identifier attribute in RADIUS requests.  No
+# NAS-IP-Address attribute will be sent in this case.
+#
+# The default behavior is to send a NAS-IP-Address option and not send
+# a NAS-Identifier.  The value of the NAS-IP-Address option is chosen
+# by resolving the system hostname.
+
+# nas_identifier MyUniqueNASName
+
+# LOCAL settings
+
+# program to execute for local login
+# it must support the -f flag for preauthenticated login
+login_local	/bin/login
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/etc/realms tomato121/release/src/router/pppd/pppd/plugins/radius/etc/realms
--- tomato/release/src/router/pppd/pppd/plugins/radius/etc/realms	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/etc/realms	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,22 @@
+# /etc/radiusclient/realms
+#
+# Handle realm @netservers.co.uk on an internal RADIUS server
+# (note the server must be told to strip the realm)
+
+#authserver netservers.co.uk 192.168.1.1:1812
+#acctserver netservers.co.uk 192.168.1.1:1813
+
+# users in realm @example.com are handled by separate servers
+
+#authserver example.com 10.0.0.1:1812
+#acctserver example.com 10.0.0.2:1813
+
+# the DEFAULT realm matches users that do not supply a realm
+
+#authserver DEFAULT 192.168.1.1:1812
+#acctserver DEFAULT 192.168.1.1:1813
+
+# Any realms that do not match in the realms file automatically fall 
+# through to the standard radius plugin which uses the servers in the 
+# radiusclient.conf file.  Note that this is different than the
+# DEFAULT realm match, above.
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/etc/servers tomato121/release/src/router/pppd/pppd/plugins/radius/etc/servers
--- tomato/release/src/router/pppd/pppd/plugins/radius/etc/servers	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/etc/servers	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,4 @@
+#Server Name or Client/Server pair		Key
+#----------------				---------------
+#portmaster.elemental.net			hardlyasecret
+#portmaster2.elemental.net	    		donttellanyone
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/includes.h tomato121/release/src/router/pppd/pppd/plugins/radius/includes.h
--- tomato/release/src/router/pppd/pppd/plugins/radius/includes.h	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/includes.h	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,54 @@
+/*
+ * $Id: includes.h,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1997 Lars Fenneberg
+ *
+ * Copyright 1992 Livingston Enterprises, Inc.
+ *
+ * Copyright 1992,1993, 1994,1995 The Regents of the University of Michigan
+ * and Merit Network, Inc. All Rights Reserved
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include <sys/types.h>
+
+#include <ctype.h>
+#include <stdio.h>
+#include <errno.h>
+#include <netdb.h>
+#include <syslog.h>
+
+#include <stdlib.h>
+#include <string.h>
+#include <stdarg.h>
+
+#include <unistd.h>
+#include <fcntl.h>
+#include <sys/stat.h>
+
+#include <limits.h>
+
+#ifndef PATH_MAX
+#define PATH_MAX        1024
+#endif
+
+#ifndef UCHAR_MAX
+# define UCHAR_MAX       255
+#endif
+
+#include <pwd.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <time.h>
+
+#include "magic.h"
+
+/* rlib/lock.c */
+int do_lock_exclusive(int);
+int do_unlock(int);
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/ip_util.c tomato121/release/src/router/pppd/pppd/plugins/radius/ip_util.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/ip_util.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/ip_util.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,137 @@
+/*
+ * $Id: ip_util.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1995,1996,1997 Lars Fenneberg
+ *
+ * Copyright 1992 Livingston Enterprises, Inc.
+ *
+ * Copyright 1992,1993, 1994,1995 The Regents of the University of Michigan
+ * and Merit Network, Inc. All Rights Reserved
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include <includes.h>
+#include <radiusclient.h>
+
+/*
+ * Function: rc_get_ipaddr
+ *
+ * Purpose: return an IP address in host long notation from a host
+ *          name or address in dot notation.
+ *
+ * Returns: 0 on failure
+ */
+
+UINT4 rc_get_ipaddr (char *host)
+{
+	struct hostent *hp;
+
+	if (rc_good_ipaddr (host) == 0)
+	{
+		return ntohl(inet_addr (host));
+	}
+	else if ((hp = gethostbyname (host)) == (struct hostent *) NULL)
+	{
+		error("rc_get_ipaddr: couldn't resolve hostname: %s", host);
+		return ((UINT4) 0);
+	}
+	return ntohl((*(UINT4 *) hp->h_addr));
+}
+
+/*
+ * Function: rc_good_ipaddr
+ *
+ * Purpose: check for valid IP address in standard dot notation.
+ *
+ * Returns: 0 on success, -1 when failure
+ *
+ */
+
+int rc_good_ipaddr (char *addr)
+{
+	int             dot_count;
+	int             digit_count;
+
+	if (addr == NULL)
+		return (-1);
+
+	dot_count = 0;
+	digit_count = 0;
+	while (*addr != '\0' && *addr != ' ')
+	{
+		if (*addr == '.')
+		{
+			dot_count++;
+			digit_count = 0;
+		}
+		else if (!isdigit (*addr))
+		{
+			dot_count = 5;
+		}
+		else
+		{
+			digit_count++;
+			if (digit_count > 3)
+			{
+				dot_count = 5;
+			}
+		}
+		addr++;
+	}
+	if (dot_count != 3)
+	{
+		return (-1);
+	}
+	else
+	{
+		return (0);
+	}
+}
+
+/*
+ * Function: rc_ip_hostname
+ *
+ * Purpose: Return a printable host name (or IP address in dot notation)
+ *	    for the supplied IP address.
+ *
+ */
+
+const char *rc_ip_hostname (UINT4 h_ipaddr)
+{
+	struct hostent  *hp;
+	UINT4           n_ipaddr = htonl (h_ipaddr);
+
+	if ((hp = gethostbyaddr ((char *) &n_ipaddr, sizeof (struct in_addr),
+			    AF_INET)) == NULL) {
+		error("rc_ip_hostname: couldn't look up host by addr: %08lX", h_ipaddr);
+	}
+
+	return ((hp==NULL)?"unknown":hp->h_name);
+}
+
+/*
+ * Function: rc_own_ipaddress
+ *
+ * Purpose: get the IP address of this host in host order
+ *
+ * Returns: IP address on success, 0 on failure
+ *
+ */
+
+UINT4 rc_own_ipaddress(void)
+{
+	static UINT4 this_host_ipaddr = 0;
+
+	if (!this_host_ipaddr) {
+		if ((this_host_ipaddr = rc_get_ipaddr (hostname)) == 0) {
+			error("rc_own_ipaddress: couldn't get own IP address");
+			return 0;
+		}
+	}
+
+	return this_host_ipaddr;
+}
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/lock.c tomato121/release/src/router/pppd/pppd/plugins/radius/lock.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/lock.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/lock.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,46 @@
+/*
+ * $Id: lock.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1997 Lars Fenneberg
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include "includes.h"
+#include <unistd.h>
+#include <fcntl.h>
+
+int do_lock_exclusive(int fd)
+{
+	struct flock fl;
+	int res;
+
+	memset((void *)&fl, 0, sizeof(fl));
+
+	fl.l_type = F_WRLCK;
+	fl.l_whence = fl.l_start = 0;
+	fl.l_len = 0; /* 0 means "to end of file" */
+
+	res = fcntl(fd, F_SETLK, &fl);
+
+	if ((res == -1) && (errno == EAGAIN))
+		errno = EWOULDBLOCK;
+
+	return res;
+}
+
+int do_unlock(int fd)
+{
+	struct flock fl;
+
+	memset((void *)&fl, 0, sizeof(fl));
+
+	fl.l_type = F_UNLCK;
+	fl.l_whence = fl.l_start = 0;
+	fl.l_len = 0; /* 0 means "to end of file" */
+
+	return fcntl(fd, F_SETLK, &fl);
+}
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/Makefile tomato121/release/src/router/pppd/pppd/plugins/radius/Makefile
--- tomato/release/src/router/pppd/pppd/plugins/radius/Makefile	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/Makefile	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,66 @@
+# Makefile for RADIUS plugin
+#
+# Copyright 2002 Roaring Penguin Software Inc.
+#
+
+DESTDIR = $(INSTROOT)@DESTDIR@
+MANDIR = $(DESTDIR)/share/man/man8
+LIBDIR = $(DESTDIR)/lib/pppd/$(VERSION)
+
+VERSION = $(shell awk -F '"' '/VERSION/ { print $$2; }' ../../patchlevel.h)
+
+INSTALL	= install
+
+PLUGIN=radius.so radattr.so radrealms.so
+COPTS = -O2
+CFLAGS=-I. -I../.. -I../../../include $(COPTS) -fPIC -DRC_LOG_FACILITY=LOG_DAEMON
+
+# Uncomment the next line to include support for Microsoft's
+# MS-CHAP authentication protocol.
+CHAPMS=y
+# Uncomment the next line to include support for MPPE.
+MPPE=y
+# Uncomment the next lint to include support for traffic limiting
+MAXOCTETS=y
+
+ifdef CHAPMS
+CFLAGS += -DCHAPMS=1
+ifdef MPPE
+CFLAGS += -DMPPE=1
+endif
+endif
+ifdef MAXOCTETS
+CFLAGS += -DMAXOCTETS=1
+endif
+
+all: $(PLUGIN)
+
+install: all
+	$(INSTALL) -d -m 755 $(LIBDIR)
+	$(INSTALL) -c -m 755 radius.so $(LIBDIR)
+	$(INSTALL) -c -m 755 radattr.so $(LIBDIR)
+	$(INSTALL) -c -m 755 radrealms.so $(LIBDIR)
+	$(INSTALL) -c -m 444 pppd-radius.8 $(MANDIR)
+	$(INSTALL) -c -m 444 pppd-radattr.8 $(MANDIR)
+
+radius.so: radius.o libradiusclient.a
+	$(CC) -o radius.so -shared radius.o libradiusclient.a
+
+radattr.so: radattr.o
+	$(CC) -o radattr.so -shared radattr.o
+
+radrealms.so: radrealms.o
+	$(CC) -o radrealms.so -shared radrealms.o
+
+CLIENTOBJS = avpair.o buildreq.o config.o dict.o ip_util.o \
+	clientid.o sendserver.o lock.o util.o md5.o
+libradiusclient.a: $(CLIENTOBJS)
+	$(AR) rv $@ $?
+
+clean:
+	rm -f *.o *.so *.a
+
+distclean:
+	rm -f *.o *.so *.a
+
+dist-clean: distclean
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/Makefile.linux tomato121/release/src/router/pppd/pppd/plugins/radius/Makefile.linux
--- tomato/release/src/router/pppd/pppd/plugins/radius/Makefile.linux	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/Makefile.linux	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,66 @@
+# Makefile for RADIUS plugin
+#
+# Copyright 2002 Roaring Penguin Software Inc.
+#
+
+DESTDIR = $(INSTROOT)@DESTDIR@
+MANDIR = $(DESTDIR)/share/man/man8
+LIBDIR = $(DESTDIR)/lib/pppd/$(VERSION)
+
+VERSION = $(shell awk -F '"' '/VERSION/ { print $$2; }' ../../patchlevel.h)
+
+INSTALL	= install
+
+PLUGIN=radius.so radattr.so radrealms.so
+COPTS = -O2
+CFLAGS=-I. -I../.. -I../../../include $(COPTS) -fPIC -DRC_LOG_FACILITY=LOG_DAEMON
+
+# Uncomment the next line to include support for Microsoft's
+# MS-CHAP authentication protocol.
+CHAPMS=y
+# Uncomment the next line to include support for MPPE.
+MPPE=y
+# Uncomment the next lint to include support for traffic limiting
+MAXOCTETS=y
+
+ifdef CHAPMS
+CFLAGS += -DCHAPMS=1
+ifdef MPPE
+CFLAGS += -DMPPE=1
+endif
+endif
+ifdef MAXOCTETS
+CFLAGS += -DMAXOCTETS=1
+endif
+
+all: $(PLUGIN)
+
+install: all
+	$(INSTALL) -d -m 755 $(LIBDIR)
+	$(INSTALL) -c -m 755 radius.so $(LIBDIR)
+	$(INSTALL) -c -m 755 radattr.so $(LIBDIR)
+	$(INSTALL) -c -m 755 radrealms.so $(LIBDIR)
+	$(INSTALL) -c -m 444 pppd-radius.8 $(MANDIR)
+	$(INSTALL) -c -m 444 pppd-radattr.8 $(MANDIR)
+
+radius.so: radius.o libradiusclient.a
+	$(CC) -o radius.so -shared radius.o libradiusclient.a
+
+radattr.so: radattr.o
+	$(CC) -o radattr.so -shared radattr.o
+
+radrealms.so: radrealms.o
+	$(CC) -o radrealms.so -shared radrealms.o
+
+CLIENTOBJS = avpair.o buildreq.o config.o dict.o ip_util.o \
+	clientid.o sendserver.o lock.o util.o md5.o
+libradiusclient.a: $(CLIENTOBJS)
+	$(AR) rv $@ $?
+
+clean:
+	rm -f *.o *.so *.a
+
+distclean:
+	rm -f *.o *.so *.a
+
+dist-clean: distclean
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/md5.c tomato121/release/src/router/pppd/pppd/plugins/radius/md5.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/md5.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/md5.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,13 @@
+/*
+ * $Id: md5.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ */
+#include "md5.h"
+
+void rc_md5_calc (unsigned char *output, unsigned char *input, unsigned int inlen)
+{
+	MD5_CTX         context;
+
+	MD5_Init (&context);
+	MD5_Update (&context, input, inlen);
+	MD5_Final (output, &context);
+}
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/options.h tomato121/release/src/router/pppd/pppd/plugins/radius/options.h
--- tomato/release/src/router/pppd/pppd/plugins/radius/options.h	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/options.h	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,59 @@
+/*
+ * $Id: options.h,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1996 Lars Fenneberg
+ *
+ * See the file COPYRIGHT for the respective terms and conditions. 
+ * If the file is missing contact me at lf@elemental.net 
+ * and I'll send you a copy.
+ *
+ */
+
+#define OPTION_LEN	64
+
+/* ids for different option types */
+#define OT_STR		(1<<0)	  /* string */
+#define OT_INT		(1<<1)	  /* integer */
+#define OT_SRV		(1<<2)	  /* server list */
+#define OT_AUO		(1<<3)    /* authentication order */
+
+#define OT_ANY		((unsigned int)~0) /* used internally */
+
+/* status types */
+#define ST_UNDEF	(1<<0)	  /* option is undefined */
+
+typedef struct _option {
+	char name[OPTION_LEN];	  /* name of the option */
+	int type, status;	  /* type and status    */
+	void *val;		  /* pointer to option value */
+} OPTION;
+
+static SERVER acctserver = {0};
+static SERVER authserver = {0};
+
+static OPTION config_options[] = {
+/* internally used options */
+{"config_file",		OT_STR, ST_UNDEF, NULL},
+/* General options */
+{"auth_order",	 	OT_AUO, ST_UNDEF, NULL},
+{"login_tries",	 	OT_INT, ST_UNDEF, NULL},
+{"login_timeout",	OT_INT, ST_UNDEF, NULL},
+{"nologin",		OT_STR, ST_UNDEF, NULL},
+{"issue",		OT_STR, ST_UNDEF, NULL},
+/* RADIUS specific options */
+{"authserver",		OT_SRV, ST_UNDEF, &authserver},
+{"acctserver",		OT_SRV, ST_UNDEF, &acctserver},
+{"servers",		OT_STR, ST_UNDEF, NULL},
+{"dictionary",		OT_STR, ST_UNDEF, NULL},
+{"login_radius",	OT_STR, ST_UNDEF, NULL},
+{"seqfile",		OT_STR, ST_UNDEF, NULL},
+{"mapfile",		OT_STR, ST_UNDEF, NULL},
+{"default_realm",	OT_STR, ST_UNDEF, NULL},
+{"radius_timeout",	OT_INT, ST_UNDEF, NULL},
+{"radius_retries",	OT_INT,	ST_UNDEF, NULL},
+{"nas_identifier",      OT_STR, ST_UNDEF, ""},
+/* local options */
+{"login_local",		OT_STR, ST_UNDEF, NULL},
+};
+
+static int num_options = ((sizeof(config_options))/(sizeof(config_options[0])));
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/pathnames.h tomato121/release/src/router/pppd/pppd/plugins/radius/pathnames.h
--- tomato/release/src/router/pppd/pppd/plugins/radius/pathnames.h	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/pathnames.h	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,28 @@
+/*
+ * $Id: pathnames.h,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1995,1996 Lars Fenneberg
+ *
+ * Copyright 1992 Livingston Enterprises, Inc.
+ *
+ * Copyright 1992,1993, 1994,1995 The Regents of the University of Michigan
+ * and Merit Network, Inc. All Rights Reserved
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#ifndef PATHNAMES_H
+#define PATHNAMES_H
+
+#define _PATH_DEV_URANDOM	"/dev/urandom"		/* Linux only */
+#define _PATH_ETC_ISSUE		"/etc/issue"
+
+/* normally defined in the Makefile */
+#ifndef _PATH_ETC_RADIUSCLIENT_CONF
+#define _PATH_ETC_RADIUSCLIENT_CONF       "/tmp/ppp/radius/radiusclient.conf"
+#endif
+
+#endif /* PATHNAMES_H */
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/radattr.c tomato121/release/src/router/pppd/pppd/plugins/radius/radattr.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/radattr.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/radattr.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,111 @@
+/***********************************************************************
+*
+* radattr.c
+*
+* A plugin which is stacked on top of radius.so.  This plugin writes
+* all RADIUS attributes from the server's authentication confirmation
+* into /var/run/radattr.pppN.  These attributes are available for
+* consumption by /etc/ppp/ip-{up,down} scripts.
+*
+* Copyright (C) 2002 Roaring Penguin Software Inc.
+*
+* This plugin may be distributed according to the terms of the GNU
+* General Public License, version 2 or (at your option) any later version.
+*
+***********************************************************************/
+
+static char const RCSID[] =
+"$Id: radattr.c,v 1.2 2004/10/28 00:24:40 paulus Exp $";
+
+#include "pppd.h"
+#include "radiusclient.h"
+#include <stdio.h>
+
+extern void (*radius_attributes_hook)(VALUE_PAIR *);
+static void print_attributes(VALUE_PAIR *);
+static void cleanup(void *opaque, int arg);
+
+char pppd_version[] = VERSION;
+
+/**********************************************************************
+* %FUNCTION: plugin_init
+* %ARGUMENTS:
+*  None
+* %RETURNS:
+*  Nothing
+* %DESCRIPTION:
+*  Initializes radattr plugin.
+***********************************************************************/
+void
+plugin_init(void)
+{
+    radius_attributes_hook = print_attributes;
+
+#if 0
+    /* calling cleanup() on link down is problematic because print_attributes()
+       is called only after PAP or CHAP authentication, but not when the link
+       should go up again for any other reason */
+    add_notifier(&link_down_notifier, cleanup, NULL);
+#endif
+
+    /* Just in case... */
+    add_notifier(&exitnotify, cleanup, NULL);
+    info("RADATTR plugin initialized.");
+}
+
+/**********************************************************************
+* %FUNCTION: print_attributes
+* %ARGUMENTS:
+*  vp -- linked-list of RADIUS attribute-value pairs
+* %RETURNS:
+*  Nothing
+* %DESCRIPTION:
+*  Prints the attribute pairs to /var/run/radattr.pppN.  Each line of the
+*  file contains "name value" pairs.
+***********************************************************************/
+static void
+print_attributes(VALUE_PAIR *vp)
+{
+    FILE *fp;
+    char fname[512];
+    char name[2048];
+    char value[2048];
+    int cnt = 0;
+
+    slprintf(fname, sizeof(fname), "/var/run/radattr.%s", ifname);
+    fp = fopen(fname, "w");
+    if (!fp) {
+	warn("radattr plugin: Could not open %s for writing: %m", fname);
+	return;
+    }
+
+    for (; vp; vp=vp->next) {
+	if (rc_avpair_tostr(vp, name, sizeof(name), value, sizeof(value)) < 0) {
+	    continue;
+	}
+	fprintf(fp, "%s %s\n", name, value);
+	cnt++;
+    }
+    fclose(fp);
+    dbglog("RADATTR plugin wrote %d line(s) to file %s.", cnt, fname);
+}
+
+/**********************************************************************
+* %FUNCTION: cleanup
+* %ARGUMENTS:
+*  opaque -- not used
+*  arg -- not used
+* %RETURNS:
+*  Nothing
+* %DESCRIPTION:
+*  Deletes /var/run/radattr.pppN
+***********************************************************************/
+static void
+cleanup(void *opaque, int arg)
+{
+    char fname[512];
+
+    slprintf(fname, sizeof(fname), "/var/run/radattr.%s", ifname);
+    (void) remove(fname);
+    dbglog("RADATTR plugin removed file %s.", fname);
+}
